﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
import argparse
import urllib
import re
import os
import codecs
os.chdir(os.path.dirname(os.path.abspath(__file__)))
#rht = re.compile(ur"((http|https|ftp)\://)?([a-z\u0430-\u044FA-Z\u0410-\u042F0-9\.\-]+(\:[a-z\u0430-\u044FA-Z\u0410-\u042F0-9\.&amp;%\$\-]+)*@)?((25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9])\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[1-9]|0)\.(25[0-5]|2[0-4][0-9]|[0-1]{1}[0-9]{2}|[1-9]{1}[0-9]{1}|[0-9])|([a-zA-Z0-9\-]+\.)*[a-zA-Z0-9\-]+\.[a-zA-Z]{2,4})(\:[0-9]+)?(/[^/][a-z\u0430-\u044FA-Z\u0410-\u042F0-9\.\,\?\'/\+&amp;%\$#\=~\\_\(\)\,\-@]*)*", re.I | re.U)
rht = re.compile(ur"(((https?)://)|www\.)[^ \n]+")
rqu = re.compile(ur"^\u0412\u043E\u043F\u0440\u043E\u0441 ?[0-9]*?[\.\:][ \t]*", re.I | re.U)
rtour = re.compile(ur"^\u0442\u0443\u0440 ?[0-9]*?[\.\:][ \t]*", re.I | re.U)
ran = re.compile(ur"^\u043E\u0442\u0432\u0435\u0442[\.\:][ \t]*", re.I | re.U)
rza = re.compile(ur"^\u0437\u0430\u0447[\u0435\u0451]\u0442[\.\:][ \t]*", re.I | re.U)
rnza = re.compile(ur"^\u043D\u0435\u0437\u0430\u0447[\u0435\u0451]\u0442[\.\:][ \t]*", re.I | re.U)
rco = re.compile(ur"^\u043A\u043E\u043C\u043C\u0435\u043D\u0442\u0430\u0440\u0438\u0439[\.\:][ \t]*", re.I | re.U)
rsos = re.compile(ur"^\u0438\u0441\u0442\u043E\u0447\u043D\u0438\u043A\u0438[\.\:][ \t]*", re.I | re.U)
rso = re.compile(ur"^\u0438\u0441\u0442\u043E\u0447\u043D\u0438\u043A(\(\u0438\))?[\.\:][ \t]*", re.I | re.U)
raus = re.compile(ur"^\u0430\u0432\u0442\u043E\u0440\u044B[\.\:][ \t]*", re.I | re.U)
rau = re.compile(ur"^\u0430\u0432\u0442\u043E\u0440(\(\u044B\))?[\.\:][ \t]*", re.I | re.U)
rperc = re.compile(ur"(%[0-9a-fA-F]{2})+")
#rqu = re.compile(u"\u0412\u043E\u043F"+r"*")
#ran = 
parser = argparse.ArgumentParser()
parser.add_argument("filename")
parser.add_argument("-sq", "--simplequestions", help="simple questions (can produce errors while handling lists of sources)",
                    action="store_true")
args = parser.parse_args()
if args.simplequestions:
	rqu = re.compile(ur"^(\u0412\u043E\u043F\u0440\u043E\u0441 )?[0-9]*?[\.\:][ \t]*", re.I | re.U)
def texrepl(zz):
	zz = re.sub(r"{",r"\{",zz) 
	zz = re.sub(r"}",r"\}",zz)
	zz = re.sub("_",r"\_",zz) 
	zz = re.sub(r"\^",r"{\\textasciicircum}",zz) 
	zz = re.sub(r"\~",r"{\\textasciitilde}",zz) 
	zz = re.sub(r"%",r"\%",zz) 
	zz = re.sub(r"\$",r"\$",zz) 
	zz = re.sub(r"#",r"\#",zz) 
	zz = re.sub(r"&",r"\&",zz) 
	zz = re.sub(r"\\",r"\\",zz) 
	zz = re.sub(r'((\"(?=[ \.\,;\:\?!\)\]]))|("(?=\Z)))',u'»',zz)
	zz = re.sub(r'(((?<=[ \.\,;\:\?!\(\[)])")|((?<=\A)"))',u'«',zz)
	zz = re.sub('"',"''",zz)
	return zz
def rexrepl(zz):
	zz = zz.replace('\\',r'\\')
	zz = zz.replace('^',r'\^')
	#zz = zz.replace('$',r'\$')
	zz = zz.replace('|',r'\|')
	zz = zz.replace('(',r'\(')
	zz = zz.replace('[',r'\[')
	zz = zz.replace(']',r'\]')
	zz = zz.replace(')',r'\)')
	zz = zz.replace('+',r'\+')
	zz = zz.replace('*',r'\*')
	zz = zz.replace('?',r'\?')
	return zz
def proc(s):
	unmatched = False
	fout = os.path.splitext(s)[0] + ".tex"
	# print(fout)
	with codecs.open(fout, encoding='utf-8', mode='w') as fw:
		fw.write("\\input{cheader.tex}\n\\begin{document}\n")
		with codecs.open(s, encoding='utf-8', mode='r') as fo:
			for line in fo:
				pref = ""
				postf = ""
				st = re.sub(u'\ufeff','',line).rstrip()
				# auto replacement for tex compliance
				#print(rht.findall(st))
				# for x in rht.findall(st):
				#st = urllib.unquote(st).decode('utf8')
				# if rperc.search(st):
				# 	print(st)
				mrex = rperc.finditer(st)
				rrex = [match.group(0) for match in mrex]
				for x in rrex:
					# print repr(x)
					# y = x.encode('ascii')
					# print repr(y)
					# z = urllib.unquote(y)
					# print repr(z)
					# t = z.decode('utf8')
					# print repr(t)
					# st = re.sub(x,t,st)
					st = re.sub(x,urllib.unquote(x.encode('ascii')).decode('utf8'),st)
				matches = rht.finditer(st)
				st = texrepl(st)
				results = [match.group(0) for match in matches]
				for x in results:
					st = re.sub(rexrepl(texrepl(x)),r'\url{'+x+"}",st, re.U | re.I)
				# ruling out question numbering:
				if rtour.search(st):
					# print('RTOUR match on line: '+st)
					pref = "\n\\"
					if unmatched == True:
						pref = "}" + pref
						unmatched = False
					st = "tour\n"
				if rqu.search(st):
					# print('RQU match on line: '+st)
					qu = rqu.search(st).group(0)
					qqu = re.search('[0-9]+',qu).group(0)
					if re.search('0+',qqu) and qqu == re.search('0+',qqu).group(0) and qqu != '':
						pref = "\n" + r"\zqu{"
					else:
						pref = "\n" + r"\qu{"
					if unmatched == True:
						pref = "}" + pref
					if qqu == '1':
						fw.write("\n"+r'\setcounter{Questions}{1}') # reset question counter
					st = st[len(qu):]
					unmatched = True
				if ran.search(st):
					# print('RAN match on line: '+st)
					an = ran.search(st).group(0)
					pref = "}\n" + r"\an{"
					st = st[len(an):]
					unmatched = True
				if rza.search(st):
					# print('RZA match on line: '+st)
					za = rza.search(st).group(0)
					pref = "}\n" + r"\za{"
					st = st[len(za):]
					unmatched = True
				if rnza.search(st):
					# print('Rnza match on line: '+st)
					nza = rnza.search(st).group(0)
					pref = "}\n" + r"\nza{"
					st = st[len(nza):]
					unmatched = True
				if rco.search(st):
					# print('Rco match on line: '+st)
					co = rco.search(st).group(0)
					pref = "}\n" + r"\co{"
					st = st[len(co):]
					unmatched = True
				if rsos.search(st):
					# print('Rsos match on line: '+st)
					sos = rsos.search(st).group(0)
					pref = "}\n" + r"\sos{"
					st = st[len(sos):]
					unmatched = True
				if rso.search(st):
					# print('Rso match on line: '+st)
					so = rso.search(st).group(0)
					pref = "}\n" + r"\so{"
					st = st[len(so):]
					unmatched = True
				if raus.search(st):
					# print('Rau match on line: '+st)
					au = raus.search(st).group(0)
					pref = "}\n" + r"\aus{"
					st = st[len(aus):] + "}\n"
					unmatched = False
				if rau.search(st):
					# print('Rau match on line: '+st)
					au = rau.search(st).group(0)
					pref = "}\n" + r"\au{"
					st = st[len(au):] + "}\n"
					unmatched = False
				# end section
				if (st!="") and (pref==""): #and unmatched == True
					pref = r"\\*"+"\n"
				fw.write(pref + st)
				#fw.write(st)
			# fw.write("blah")
			# fw.write("blah")
			# fw.write("blah")
			if unmatched == True:
				fw.write("}")
				unmatched = False
			fw.write("\n"+r"\end{document}")
	print("Done!")
	os.system('pause')

if os.path.exists(args.filename):
	print("Opening file: "+args.filename.encode('ascii','replace'))
	proc(args.filename)
else:
	print("Error: file "+args.filename.encode('ascii','replace')+" does not exist!")